#pragma once

#include <string>
#include <vector>

#define BASE64_FLAG_NONE	0
#define BASE64_FLAG_NOPAD	1
#define BASE64_FLAG_NOCRLF  2

using namespace std;

class CAESCrypto
{
private:
	//std::string m_strSeed;
	std::vector<char> m_enc64ID;

public:
	CAESCrypto(void);
	~CAESCrypto(void);

void * pwdcrypt_init(const char * seed, const char * key_base_table, int key_base_table_len);
void pwdcrypt_free(void * handle);

bool pwdcrypt_encrypt(const char * data, int data_len,
					  unsigned char * pOutBuffer, int * pOutBufferLen,
					  const char * seed,
					  const char * key_base_table, int key_base_table_len);
					  
bool pwdcrypt_decrypt(const unsigned char * data, int data_len,
					  char * pOutBuffer, int * pOutBufferLen,
					  const char * seed,
					  const char * key_base_table, int key_base_table_len);

//  Լ Windows ⺻ ȣȭ Լ Ͽ SHA256 Hash Ѵ. 
// ׷ Windows XP SP3 ̻󿡼 ϴ  Ƿ Ʒ GetSHA256()Լ Ѵ.
BOOL GetSHA256Hash(char *buffer, DWORD dwBufferSize, BYTE *byteFinalHash, DWORD *dwFinalHashSize);

BOOL GetSHA256(char* pSrc, size_t dwSrcLength, BYTE* byteSHA256Hash);

BOOL Base64Encode(const BYTE *pbSrcData, int nSrcLen, LPSTR szDest, int *pnDestLen, DWORD dwFlags=BASE64_FLAG_NONE) throw();

};
